package com.example.observer;

import graphql.schema.GraphQLSchema;
import graphql.schema.GraphQLTypeVisitor;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;

/**
 * Component to observe an event right before the {@link GraphQLSchema} is built
 */
@ApplicationScoped
public class GraphQLSchemaObserver {

    @Inject
    GraphQLTypeVisitor visitor;

    /**
     * Transform {@link GraphQLSchema} and update graphql federation directives to
     * match <i>Apollo</i> contract. Uncomment the method below to update directives.
     *
     * @param schemaBuilder {@link GraphQLSchema.Builder} builder
     * @return {@link GraphQLSchema.Builder} builder
     */
//    public GraphQLSchema.Builder transform(@Observes GraphQLSchema.Builder schemaBuilder) {
//        GraphQLSchema schema = SchemaTransformer.transformSchema(schemaBuilder.build(), visitor);
//        return schemaBuilder.clearAdditionalTypes().additionalTypes(schema.getAdditionalTypes());
//    }
}
